#include <iostream>
#include <queue>
using namespace std;

struct State
{
    int i, j, state, mask, lvl, prev;
    State(int _i, int _j, int _state, int _mask, int _lvl, int _prev):
     i(_i), j(_j), state(_state), mask(_mask), lvl(_lvl), prev(_prev){}
    State(){}
};

int StartMask, doors;
bool used[20][20][3][1<<10];
int Board[20][20]; // 0 - whole, 1 - not whole, -1 - broken
int pi[10], pj[10], T[20];
int K[20][10][3];
int Begi, Begj, Endi, Endj;
int N, M;

int activate(int k, int mask)
{
    k -= 10;
    for (int i = 0; i < T[k]; i++)
    {
        //cout << K[k][i][1] << endl;
        if (K[k][i][1] != -1)      mask |= (1<<K[k][i][1]);
        else if (K[k][i][0] != -1) mask &= ~(1<<K[k][i][0]);
        else if (K[k][i][2] != -1) mask ^= (1<<K[k][i][2]);
    }
    return mask;
}

State st[20*20*3*(1<<10)+100];
char  pr[20*20*3*(1<<10)+100];
int cnt;

void BFS()
{
     queue<State> q;
     st[cnt++] = State(Begi, Begj, 0, StartMask, 0, -1);     
     used[Begi][Begj][0][StartMask] = 1;
     q.push(st[0]);
     
     int E = -1;
     while (!q.empty())
     {
            State s = q.front();
            q.pop();
            
            st[cnt++] = s;
            int cur = cnt-1;
            int i = s.i, j = s.j, state = s.state, mask = s.mask, lvl = s.lvl;
            int B[20][20];
            memcpy(B, Board, sizeof(Board));
            /*
            if (state == 0) B[i][j] = 3;
            else if (state == 1) B[i][j] = B[i][j+1] = 3;
            else B[i][j] = B[i+1][j] = 3;                       
            
            cout << B[1][0] << endl;
            for (int i = 0; i < N; i++)
            {
             for (int j = 0; j < M; j++) if (B[i][j]>=10) cout << "K";
                                         else cout << B[i][j]; cout << endl;}
            cout << endl;
*/
            if (i == Endi && j == Endj && state == 0)
            {
                cout << lvl << endl;
                E = cur;      
                break;
            }
            
            if (doors)
            for (int k = (1<<(doors-1)), y = doors-1; k > 0; k >>= 1, y--)
             B[ pi[y] ][ pj[y] ] = (bool)(k&mask);            
            
            if (state == 0) // the motherfucker is up
            {
                 if (j + 2 < M && B[i][j+1] != 0 && B[i][j+2] != 0)
                 {   
                     int newmask = mask;
                     if (B[i][j+1] >= 10) newmask = activate( B[i][j+1], newmask );
                     if (B[i][j+2] >= 10) newmask = activate( B[i][j+2], newmask );  
                     if (!used[i][j+1][1][newmask])
                     {
                            used[i][j+1][1][newmask] = 1;
                            q.push(State(i, j+1, 1, newmask, lvl + 1, cur));
                     }
                 } 
                 if (j - 2 >= 0 && B[i][j-1] != 0 && B[i][j-2] != 0)
                 {
                     int newmask = mask;
                     if (B[i][j-1] >= 10) newmask = activate( B[i][j-1], newmask );
                     if (B[i][j-2] >= 10) newmask = activate( B[i][j-2], newmask );
                     if (!used[i][j-2][1][newmask])
                     {
                            used[i][j-2][1][newmask] = 1;
                            q.push(State(i, j-2, 1, newmask, lvl + 1, cur));
                     }
                 }
                 if (i + 2 < N && B[i+1][j] != 0 && B[i+2][j] != 0)
                 {
                    int newmask = mask;
                    if (B[i+1][j] >= 10) newmask = activate( B[i+1][j], newmask);
                    if (B[i+2][j] >= 10) newmask = activate( B[i+2][j], newmask);
                    if (!used[i+1][j][2][newmask])
                    {
                        used[i+1][j][2][newmask] = 1;
                        q.push(State(i+1, j, 2, newmask, lvl + 1, cur));
                    }
                 }
                 if (i - 2 >= 0 && B[i-1][j] != 0 && B[i-2][j] != 0)
                 {
                    int newmask = mask;
                    if (B[i-1][j] >= 10) newmask = activate( B[i-1][j], newmask);
                    if (B[i-2][j] >= 10) newmask = activate( B[i-2][j], newmask);
                    if (!used[i-2][j][2][newmask])
                    {
                        used[i-2][j][2][newmask] = 1;
                        q.push(State(i-2, j, 2, newmask, lvl + 1, cur));
                    }
                 }
            }
            if (state == 1)
            {
                 if (i + 1 < N && B[i+1][j] != 0 && B[i+1][j+1] != 0)
                 {
                    int newmask = mask;
                    if (B[i+1][j] >= 10) newmask = activate(B[i+1][j], newmask);
                    if (B[i+1][j+1] >= 10) newmask = activate(B[i+1][j+1],newmask);
                    if (!used[i+1][j][1][newmask])
                    {
                        used[i+1][j][1][newmask] = 1;
                        q.push(State(i+1, j, 1, newmask, lvl + 1, cur));
                    }
                 }
                 if (i - 1 >= 0 && B[i-1][j] != 0 && B[i-1][j+1] != 0)
                 {
                    int newmask = mask;
                    if (B[i-1][j] >= 10) newmask = activate(B[i-1][j], newmask);
                    if (B[i-1][j+1] >= 10) newmask = activate(B[i-1][j+1], newmask);
                    if (!used[i-1][j][1][newmask])
                    {
                        used[i-1][j][1][newmask] = 1;
                        q.push(State(i-1, j, 1, newmask, lvl + 1, cur));
                    }
                 }
                 if (j - 1 >= 0 && B[i][j-1] > 0)
                 {
                    int newmask = mask;
                    if (B[i][j-1] >= 10) newmask = activate(B[i][j-1], newmask);
                    if (!used[i][j-1][0][newmask])
                    {
                        used[i][j-1][0][newmask] = 1;
                        q.push(State(i, j-1, 0, newmask, lvl + 1, cur));
                    }
                 }
                 if (j + 2 < M && B[i][j+2] > 0)
                 {
                    int newmask = mask;
                    if (B[i][j+2] >= 10) newmask = activate(B[i][j+2], newmask);
                    if (!used[i][j+2][0][newmask])
                    {
                        used[i][j+2][0][newmask] = 1;
                        q.push(State(i, j+2, 0, newmask, lvl + 1, cur));
                    }
                 }
            }
            if (state == 2)
            {
                if (j + 1 < M && B[i][j+1] != 0 && B[i+1][j+1] != 0)
                {
                    int newmask = mask;
                    if (B[i][j+1] >= 10) newmask = activate(B[i][j+1], newmask);
                    if (B[i+1][j+1] >= 10) newmask = activate(B[i+1][j+1], newmask);
                    if (!used[i][j+1][2][newmask])
                    {
                        used[i][j+1][2][newmask] = 1;
                        q.push(State(i, j+1, 2, newmask, lvl + 1, cur));
                    }
                }
                if (j - 1 >= 0 && B[i][j-1] != 0 && B[i+1][j-1] != 0)
                {
                    int newmask = mask;
                    if (B[i][j-1] >= 10) newmask = activate(B[i][j-1], newmask);
                    if (B[i+1][j-1] >= 10) newmask = activate(B[i+1][j-1], newmask);
                    if (!used[i][j-1][2][newmask])
                    {
                        used[i][j-1][2][newmask] = 1;
                        q.push(State(i, j-1, 2, newmask, lvl + 1, cur));
                    }
                }
                if (i - 1 >= 0 && B[i-1][j] > 0)
                {
                    int newmask = mask;
                    if (B[i-1][j] >= 10) newmask = activate(B[i-1][j], newmask);
                    if (!used[i-1][j][0][newmask])
                    {
                        used[i-1][j][0][newmask] = 1;
                        q.push(State(i-1, j, 0, newmask, lvl + 1, cur));
                    }
                }
                if (i + 2 < N && B[i+2][j] > 0)
                {
                    int newmask = mask;
                    if (B[i+2][j] >= 10) newmask = activate(B[i+2][j], newmask);
                    if (!used[i+2][j][0][newmask])
                    {
                        used[i+2][j][0][newmask] = 1;
                        q.push(State(i+2, j, 0, newmask, lvl + 1, cur));
                    }
                }
            }
     }     
     
     if (E == -1) {cout << "0" << endl; return;}
     string S;
     while (st[E].prev != -1)
     {
            int P = st[E].prev;
            if (st[P].j > st[E].j) S += 'l';
            else if (st[P].j < st[E].j) S += 'r';
            else if (st[P].i > st[E].i) S += 'u';
            else S += 'd';
            
            E = P;
     }
     reverse(S.begin(), S.end());
     cout << S << endl;
}

int main()
{
    memset(K, -1, sizeof(K));
    cin >> N >> M;
    
    int cntk = 0;
    for (int i = 0; i < N; i++)
     for (int j = 0; j < M; j++)
     {
            char c;
            cin >> c;
            if (c == '.') Board[i][j] = 1;
            if (c == '_') Board[i][j] = 0;
            if (c == '^') Board[i][j] = -1;
            if (c >= '0' && c <= '9') 
             pi[ c-'0' ] = i,
             pj[ c-'0' ] = j, doors++;
            if (c == 'K')
                Board[i][j] = 10+cntk,
                cntk++;
            if (c == 'S') Begi = i, Begj = j, Board[i][j] = 1;
            if (c == 'E') Endi = i, Endj = j, Board[i][j] = 1; 
     }
     
     char c; c = getchar();
     for (int i = 0; i < cntk; i++)
      for (int j = 0;;j++)
      {
            c = getchar();
            if (c == '\n') break;
            
            char b = getchar();
            if (c == 'O') K[i][j][1] = b - '0';
            if (c == 'C') K[i][j][0] = b - '0';
            if (c == 'T') K[i][j][2] = b - '0';
            
            c = getchar();
            if (c == '\n') { T[i] = j+1; break; }
      }
     
     //cout << doors << endl;
     for (int i = 0; i < doors; i++)
     {
            char c2;
            cin >> c2;
            Board[ pi[i] ][ pj[i] ] = c2-'0',
            StartMask ^= ((c2-'0')<<i);
     }
    // cout << StartMask << endl;
     //cout << Endi << " " << Endj << endl;
     BFS();
     
     /*cout << activate(10, 0) << endl;
     cout << StartMask << endl;
     cout << Begi << " " << Begj << " " << Endi << " " << Endj << endl;
     for (int i = 0; i < strlen(c2); i++) cout << pi[i] << " " << pj[i] << endl;
     
     for (int i = 0; i < cntk; i++)
     {
            for (int j = 0; j < T[i]; j++)
             if (K[i][j][0] != -1) cout << "C " << K[i][j][0] << endl;
             else if (K[i][j][1] != -1) cout << "O " << K[i][j][1] << endl;
             else if (K[i][j][2] != -1) cout << "T " << K[i][j][2] << endl;
     }  
     for (int i = 0; i < N; i++)
     {
          for (int j = 0; j < M; j++)
           cout << Board[i][j] << " ";
          cout << endl;
     }
     system("pause");*/
     return 0;
}
