#include <cstdio>
#include <iostream>
#include <cstdlib>
#include <set>
#include <vector>

using namespace std;

#define f(i, n) for(int i = 0; i < (n); i ++)
#define ff(i, st, end) for(int i = (st); i < (end); i ++)
#define fv(i, v) for(int i = 0; i < int((v).size()); i ++)
#define fx(i, v) for(typeof( (v).begin() ) it = (v).begin(); it != (v).end(); it ++)
#define all(v) (v).begin(), (v).end()

#define STABLE 10
#define HOLE 11
#define BREAKABLE 12
#define KEY 128
#define DOOR 1024


// COMPILE WITH -O3 !!!!!!!!!!!!!!!!!!!!!!!!!

int n,m, keys, doors;
char c;
int doorX[15], keyX[25];
int doorY[15], keyY[25];
int table[30][30];

int cX[2], cY[2], len;
int cXbu[2], cYbu[2], lenbu;
int dX[2], dY[2];
int endX, endY;

char	action[25][15];					//
int		door[25][15];					//
int		topKeys[25];					// info about the keys: action - what, door - which door

//bool	state[15];						// door state
//bool	statebu[15];
vector<bool> state;
vector<bool> statebu;

char res[1000], s[1000];
char best[1000];
int topRes, bestlen = INT_MAX;
int start;								// how far have we read s

bool check()
{
	f(i, len)
	{
		if( (cX[i] < 0) || (cX[i] > n) || (cY[i] < 0) || (cY[i] > m) )
		{
//			cout << "1\n";
//			cout << cX[i] << " " << cY[i] << "\n";
			return 0;
		}
		if( table[ cX[i] ][ cY[i] ] == HOLE )
		{
//			cout << "2\n";
			return 0;
		}		
		if( (table[ cX[i] ][ cY[i] ] & DOOR) &&
		  ( state[ table[ cX[i] ][ cY[i] ] - DOOR ] == 0 ))				
		{
//			cout << "3\n";
			return 0;
		}
	}
	if( (len == 1) && (table[ cX[0] ][ cY[0] ] == BREAKABLE) )			return 0;
	return 1;
}


set<vector<bool> > used[2][21][21][21][21][4];

void dfs()
{
	if( topRes > bestlen )	return;
//	f(i, len) cout << cX[i] << " " << cY[i] << "\n";
//	cout << "wtf\n";
	if( (len == 1) && ( cX[0] == endX ) && (cY[0] == endY) )
	{
/*		printf("%d\n", topRes);
		f(i, topRes)	printf("%c", res[i]);
		printf(" ans\t\t\t braaat\n"); */
		memcpy(best,res,topRes);
		bestlen = topRes;
//		exit(0);
	}
	
	// Move left
	
	if( used[len - 1][ cX[0] ][ cY[0] ][ cX[1] ][ cY[1] ][0].count(state) == 0 )
	{
//		cout << "in left\n";
		used[len - 1][ cX[0] ][ cY[0] ][ cX[1] ][ cY[1] ][0].insert(state);
//		cout << "in left 1\n";
	memcpy(cXbu, cX, sizeof(cX));
	memcpy(cYbu, cY, sizeof(cX));
	lenbu = len;
//	memcpy(statebu, state, sizeof(state));
	statebu = state;
//	cout << "wtf \n";
	if(len == 1)
	{
//		cout << "OK len=1\n";
		len = 2;
		dY[0] = cY[0] - 2; dY[1] = cY[0] - 1;
		dX[0] = dX[1] = cX[0];
		memcpy(cX, dX, sizeof(cX));
		memcpy(cY, dY, sizeof(cX));
	}
	else
		if( cX[0] == cX[1] )
		{
			len = 1;
			dY[0] = cY[0] - 1; dX[0] = cX[0];
			dY[1] = dX[1] = 20;
			memcpy(cX, dX, sizeof(dX));
			memcpy(cY, dY, sizeof(dX));
		}
		else
		{
			len = 2;
			dY[0] = cY[0] - 1;	dY[1] = cY[1] - 1;
			dX[0] = cX[0];		dX[1] = cX[1];
			memcpy(cX, dX, sizeof(cX));
			memcpy(cY, dY, sizeof(cX));
		}
//	cout << "ok bfor check\n";
	if( check() )
	{
//		cout << "OK check\n";
		f(i, len)
			if( table[ cX[i] ][ cY[i] ] & KEY )
			{
				int num = table[ cX[i] ][ cY[i] ] - KEY;
				f(j, topKeys[ num ])
				{
					if( action[num][j] == 'O' )	state[ door[num][i] ] = 1;
					if( action[num][j] == 'C' )	state[ door[num][i] ] = 0;
					if( action[num][j] == 'T' )	state[ door[num][i] ] = !state[ door[num][i] ];
				}
			}
		res[topRes ++] = 'l';
		dfs();
		topRes --;
	}
	
	memcpy(cX, cXbu, sizeof(cX));
	memcpy(cY, cYbu, sizeof(cX));
	len = lenbu;
//	memcpy(state, statebu, sizeof(state));
	state = statebu;
	
	}
	// end Move left
	
	
	// Move right
	
	if( used[len - 1][ cX[0] ][ cY[0] ][ cX[1] ][ cY[1] ][1].count(state) == 0 )
	{
		used[len - 1][ cX[0] ][ cY[0] ][ cX[1] ][ cY[1] ][1].insert(state);
	
	memcpy(cXbu, cX, sizeof(cX));
	memcpy(cYbu, cY, sizeof(cX));
	lenbu = len;
//	memcpy(statebu, state, sizeof(state));
	statebu = state;
	if(len == 1)
	{
//		cout << "OK len=1\n";
		len = 2;
		dY[0] = cY[0] + 1; dY[1] = cY[0] + 2;
		dX[0] = dX[1] = cX[0];
		memcpy(cX, dX, sizeof(cX));
		memcpy(cY, dY, sizeof(cX));
	}
	else
		if( cX[0] == cX[1] )
		{
			len = 1;
			dY[0] = cY[0] + 2; dX[0] = cX[0];
			dX[1] = dY[1] = 20;
			memcpy(cX, dX, sizeof(cX));
			memcpy(cY, dY, sizeof(cX));
		}
		else
		{
			len = 2;
			dY[0] = cY[0] + 1;	dY[1] = cY[1] + 1;
			dX[0] = cX[0];		dX[1] = cX[1];
			memcpy(cX, dX, sizeof(cX));
			memcpy(cY, dY, sizeof(cX));
		}
//	cout << "ok bfor check\n";
	if( check() )
	{
//		cout << "OK check\n";
		f(i, len)
			if( table[ cX[i] ][ cY[i] ] & KEY )
			{
				int num = table[ cX[i] ][ cY[i] ] - KEY;
				f(j, topKeys[ num ])
				{
					if( action[num][j] == 'O' )	state[ door[num][i] ] = 1;
					if( action[num][j] == 'C' )	state[ door[num][i] ] = 0;
					if( action[num][j] == 'T' )	state[ door[num][i] ] = !state[ door[num][i] ];
				}
			}
		res[topRes ++] = 'r';
		dfs();
		topRes --;
	}
	
	memcpy(cX, cXbu, sizeof(int) * len);
	memcpy(cY, cYbu, sizeof(int) * len);
	len = lenbu;
//	memcpy(state, statebu, sizeof(state));	
	state = statebu;
	}
	
	// end Move right
	
	
	// Move down
	
	if( used[len - 1][ cX[0] ][ cY[0] ][ cX[1] ][ cY[1] ][2].count(state) == 0 )
	{
		used[len - 1][ cX[0] ][ cY[0] ][ cX[1] ][ cY[1] ][2].insert(state);
	
	memcpy(cXbu, cX, sizeof(cX));
	memcpy(cYbu, cY, sizeof(cX));
	lenbu = len;
//	memcpy(statebu, state, sizeof(state));
	statebu = state;
	if(len == 1)
	{
//		cout << "OK len=1\n";
		len = 2;
		dX[0] = cX[0] + 1; dX[1] = cX[0] + 2;
		dY[0] = dY[1] = cY[0];
		memcpy(cX, dX, sizeof(cX));
		memcpy(cY, dY, sizeof(cX));
	}
	else
		if( cY[0] == cY[1] )
		{
			len = 1;
			dX[0] = cX[0] + 2; dY[0] = cY[0];
			dX[1] = dY[1] = 20;
			memcpy(cX, dX, sizeof(cX));
			memcpy(cY, dY, sizeof(cX));
		}
		else
		{
			len = 2;
			dX[0] = cX[0] + 1;	dX[1] = cX[1] + 1;
			dY[0] = cY[0];		dY[1] = cY[1];
			memcpy(cX, dX, sizeof(cX));
			memcpy(cY, dY, sizeof(cX));
		}
//	cout << "ok bfor check\n";
	if( check() )
	{
//		cout << "OK check\n";
		f(i, len)
			if( table[ cX[i] ][ cY[i] ] & KEY )
			{
				int num = table[ cX[i] ][ cY[i] ] - KEY;
				f(j, topKeys[ num ])
				{
					if( action[num][j] == 'O' )	state[ door[num][i] ] = 1;
					if( action[num][j] == 'C' )	state[ door[num][i] ] = 0;
					if( action[num][j] == 'T' )	state[ door[num][i] ] = !state[ door[num][i] ];
				}
			}
		res[topRes ++] = 'd';
		dfs();
		topRes --;
	}
	
	memcpy(cX, cXbu, sizeof(int) * len);
	memcpy(cY, cYbu, sizeof(int) * len);
	len = lenbu;
//	memcpy(state, statebu, sizeof(state));	
	state = statebu;
	}
	
	// end Move down
	
	
	// Move up
	
	if( used[len - 1][ cX[0] ][ cY[0] ][ cX[1] ][ cY[1] ][3].count(state) == 0 )
	{
//		cout << "in left\n";
		used[len - 1][ cX[0] ][ cY[0] ][ cX[1] ][ cY[1] ][3].insert(state);
//		cout << "in left 1\n";
	memcpy(cXbu, cX, sizeof(cX));
	memcpy(cYbu, cY, sizeof(cX));
	lenbu = len;
//	memcpy(statebu, state, sizeof(state));
	statebu = state;
//	cout << "wtf \n";
	if(len == 1)
	{
//		cout << "OK len=1\n";
		len = 2;
		dX[0] = cX[0] - 2; dX[1] = cX[0] - 1;
		dY[0] = dY[1] = cY[0];
		memcpy(cX, dX, sizeof(cX));
		memcpy(cY, dY, sizeof(cX));
	}
	else
		if( cY[0] == cY[1] )
		{
			len = 1;
			dX[0] = cX[0] - 1; dY[0] = cY[0];
			dY[1] = dX[1] = 20;
			memcpy(cX, dX, sizeof(dX));
			memcpy(cY, dY, sizeof(dX));
		}
		else
		{
			len = 2;
			dX[0] = cX[0] - 1;	dX[1] = cX[1] - 1;
			dY[0] = cY[0];		dY[1] = cY[1];
			memcpy(cX, dX, sizeof(cX));
			memcpy(cY, dY, sizeof(cX));
		}
//	cout << "ok bfor check\n";
	if( check() )
	{
//		cout << "OK check\n";
		f(i, len)
			if( table[ cX[i] ][ cY[i] ] & KEY )
			{
				int num = table[ cX[i] ][ cY[i] ] - KEY;
				f(j, topKeys[ num ])
				{
					if( action[num][j] == 'O' )	state[ door[num][i] ] = 1;
					if( action[num][j] == 'C' )	state[ door[num][i] ] = 0;
					if( action[num][j] == 'T' )	state[ door[num][i] ] = !state[ door[num][i] ];
				}
			}
		res[topRes ++] = 'l';
		dfs();
		topRes --;
	}
	
	memcpy(cX, cXbu, sizeof(cX));
	memcpy(cY, cYbu, sizeof(cX));
	len = lenbu;
//	memcpy(state, statebu, sizeof(state));
	state = statebu;
	
	}
	// end Move up
	
}


int main()
{
	scanf("%d %d", &n, &m); getc(stdin);
	f(i, n) 
	{
		f(j, m)
		{
			c = getc(stdin);
			if( isdigit( c ) )
			{
				doorX[ c - '0' ] = i;
				doorY[ c - '0' ] = j;
				table[i][j] = DOOR + c - '0';
				doors ++;
			}
			if( c == 'K' )
			{
				keyX[ keys ] = i;
				keyY[ keys ] = j;
				table[i][j] = KEY + keys ++;
			}
			if( c == '.' )
				table[i][j] = STABLE;
			if( c == '_' )
				table[i][j] = HOLE;
			if( c == '^')
				table[i][j] = BREAKABLE;
			if( c == 'S' )
			{
				len = 1;
				cX[0] = i; cY[0] = j;
				cX[1] = cY[1] = 20;
				table[i][j] = STABLE;
			}
			if( c == 'E' )
			{
				endX = i;
				endY = j;
				table[i][j] = STABLE;
			}
		}
		getc(stdin);
	}
	f(i, keys)
	{
		start = 0;
		gets(s);
		char c; int cur;
		while(sscanf(s + start, "%c%d", &c, &cur ) == 2)
		{
			action[i][ topKeys[i] ]	= c;
			door[i][ topKeys[i] ]	= cur;
			topKeys[i]				++;
			start +=3;
		}
	}
//	f(i, doors) scanf("%d", &state[i]);
	state.resize(15);
	f(i, doors){ char c; scanf("%c", &c); state[i] = (c == '1'); }
//	f(i, n) { f(j, m) printf("%d ", table[i][j]); puts(""); }
	
	dfs();
	
	if(bestlen == INT_MAX)
	{
		cout << "0\n";
		return 0;
	}
	f(i, bestlen) cout << best[i];	cout << "\n";
	
    return 0;
}
