#include <cstdio>

const int MAX_N = 24;
const int MAX_V = 50001;
const int MAX_S = MAX_N * MAX_V;

int N, S, T, B, ans;
int a[MAX_N], b[MAX_N], s[1 << MAX_N];
bool dp[MAX_S];

void Read()
{
	scanf("%d", &N);
	
	for(int i = 0; i < N; i ++)
	{
		scanf("%d", &a[i]);
		
		S += a[i];
	}
}

bool ok()
{
	for(int i = 0; i <= S; i ++) dp[i] = false;
	dp[0] = true;
	
	for(int i = 0; i < B; i ++)
	{
		for(int sum = S - b[i]; 0 <= sum; sum --)
		{
			dp[sum + b[i]] |= dp[sum];
		}
	}
	
	return dp[T];
}

void Solve()
{
	if(0 < S % 3) return;
	
	T = S / 3;
	
	for(int mask = 0; mask < (1 << N); mask ++) if(0 <= s[mask])
	{
		if(s[mask] == T)
		{
			B = 0;
			
			for(int i = 0; i < N; i ++) if(!(mask & (1 << i)))
			{
				b[B ++] = a[i];
			}
			
			if(ok())
			{
				ans = 1;
				
				return;
			}
		}
		
		for(int i = 0; i < N; i ++) if(!(mask & (1 << i)))
		{
			int new_mask = mask | (1 << i);
			
			s[new_mask] = s[mask] + a[i];
			
			if(T < s[new_mask]) s[new_mask] = - 1;
		}
	}
}

void Write()
{
	 printf("%d\n", ans);
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
	return 0;
}
