#include <iostream>
#include <sstream>
#define PATH -1
#define HOLE -2
#define GL -3
#define END -4
#define KEY -5
using namespace std;

const int MAXN = 21;
int i, j, n, m, sx, sy, br, doors, p, l, code, scode, temp, x, y;
bool u[3][21][21][1024];
int c[10];
int a[21][21];
int k[21][21]; // vryshta nomer na kliuch
int v[21][10]; // v[i][j] kakvo pravi s vrata j kluch i
int d[3*21*21*1024];
int prev[3*21*21*1024];
char move[3*21*21*1024];
char ans[1024];
int cnt;

struct P {
    int p, x, y, v;
    P () {}
    P (int _p, int _x, int _y, int _v): p (_p), x (_x), y (_y), v (_v) {}
} q[3*21*21*1024], beg;

int code_d () {
    for (l = 0, code = 0; l < doors; l++) code += c[l] * (1 << l);
}

int get_d () {
    for (l = 0; l < doors; l++)
        if (code & (1 << l)) c[l] = 1;
        else c[l] = 0;
}

bool proceed (int x1, int y1, int x2, int y2, int np) {
    //for (j = 0; j < doors; j++) printf ("(%d)", c[j]);
    //printf ("%d %d %d %d\n", x1, y1, x2, y2);
    if (x1 < 1 || y1 < 1 || x1 > n || y1 > m) return 0;
    if (a[x1][y1] == HOLE) return 0;
    if (np) {
        if (x2 < 1 || y2 < 1 || x2 > n || y2 > m) return 0;
        if (a[x2][y2] == HOLE) return 0;
    }
    
    if (np == 0 && a[x1][y1] == GL) return 0;

    if (a[x1][y1] >= 0 && !c[a[x1][y1]]) return 0;
    if (np) if (a[x2][y2] >= 0 && !c[a[x2][y2]]) return 0;

    int key;
    if (a[x1][y1] == KEY) {
        key = k[x1][y1]; //printf ("[%d %d]", v[key][0], v[key][1]);
        for (j = 0; j < doors; j++) {
            switch (v[key][j]) {
                case 1: c[j] = 1; break;
                case 2: c[j] = 0; break;
                case 3: if (c[j]) c[j] = 0; else c[j] = 1; break;
            }
        }
    }
    if (np) {
        if (a[x2][y2] == KEY) {
            key = k[x2][y2];
            for (j = 0; j < doors; j++) {
                switch (v[key][j]) {
                    case 1: c[j] = 0; break;
                    case 2: c[j] = 1; break;
                    case 3: if (c[j]) c[j] = 0; else c[j] = 1; break;
                }
            }
        }
    }
    code_d ();
    //printf ("{%d}\n", code);
    if (u[np][x1][y1][code]) return 0;
    q[++br] = P (np, x1, y1, code);
    u[np][x1][y1][code] = 1;
    d[br] = d[temp] + 1;
    prev[br] = temp;
    return 1;
}

void solve () {
    beg.p = 0;
    beg.x = sx; beg.y = sy;
    code_d ();
    beg.v = code;
    br = 0;
    temp = 1;
    int x1, y1, x2, y2, np, nc, scode;
    q[++br] = beg;
    u[beg.p][beg.x][beg.y][beg.v] = 1;
    while (temp <= br) {
        p = q[temp].p;
        x = q[temp].x;
        y = q[temp].y;
        code = scode = q[temp].v;
        get_d (); // dekodirane na vratite
        x1 = y1 = x2 = y2 = -5;
        // up
        if (p == 0) {
            np = 2;
            x1 = x-2; y1 = y; x2 = x-1; y2 = y;
        }
        if (p == 1) {
            np = 1;
            x1 = x-1; y1 = y; x2 = x-1; y2 = y+1;
        }
        if (p == 2) {
            np = 0;
            x1 = x-1; y1 = y; x2 = -5;
        }
        if (proceed (x1, y1, x2, y2, np)) {
            move[br] = 'u';
            //printf ("%d added UP\n", d[br]);
            if (np == 0 && a[x1][y1] == END) {
                printf ("%d\n", d[br]);
                int pr = br;
                while (prev[pr] != 0) {
                    ans[++cnt] = move[pr];
                    pr = prev[pr];
                }
                for (j = cnt; j >= 1; j--) printf ("%c", ans[j]);
                printf ("\n");
                return;
            }
        }
        code = scode;
        get_d ();
        // right
        if (p == 0) {
            np = 1;
            x1 = x; y1 = y+1; x2 = x; y2 = y+2;
        }
        if (p == 1) {
            np = 0;
            x1 = x; y1 = y+2; x2 = -5;
        }
        if (p == 2) {
            np = 2;
            x1 = x; y1 = y+1; x2 = x+1; y2 = y+1;
        }
        if (proceed (x1, y1, x2, y2, np)) {
            move[br] = 'r';
            //printf ("%d added RIGHT\n", d[br]);
            if (np == 0 && a[x1][y1] == END) {
                printf ("%d\n", d[br]);
                int pr = br;
                while (prev[pr] != 0) {
                    ans[++cnt] = move[pr];
                    pr = prev[pr];
                }
                for (j = cnt; j >= 1; j--) printf ("%c", ans[j]);
                printf ("\n");
                return;
            }
        }
        // down
        if (p == 0) {
            np = 2;
            x1 = x+1; y1 = y; x2 = x+2; y2 = y;
        }
        if (p == 1) {
            np = 1;
            x1 = x+1; y1 = y; x2 = x+1; y2 = y+1;
        }
        if (p == 2) {
            np = 0;
            x1 = x+2; y1 = y; x2 = -5;
        }
        if (proceed (x1, y1, x2, y2, np)) {
            move[br] = 'd';
            //printf ("%d added DOWN\n", d[br]);
            if (np == 0 && a[x1][y1] == END) {
                printf ("%d\n", d[br]);
                int pr = br;
                while (prev[pr] != 0) {
                    ans[++cnt] = move[pr];
                    pr = prev[pr];
                }
                for (j = cnt; j >= 1; j--) printf ("%c", ans[j]);
                printf ("\n");
                return;
            }
        }
        // left
        if (p == 0) {
            np = 1;
            x1 = x; y1 = y-2; x2 = x; y2 = y-1;
        }
        if (p == 1) {
            np = 0;
            x1 = x; y1 = y-1; x2 = -5;
        }
        if (p == 2) {
            np = 2;
            x1 = x; y1 = y-1; x2 = x+1; y2 = y-1;
        }
        if (proceed (x1, y1, x2, y2, np)) {
            move[br] = 'l';
            //printf ("%d added LEFT\n", d[br]);
            if (np == 0 && a[x1][y1] == END) {
                printf ("%d\n", d[br]);
                int pr = br;
                while (prev[pr] != 0) {
                    ans[++cnt] = move[pr];
                    pr = prev[pr];
                }
                for (j = cnt; j >= 1; j--) printf ("%c", ans[j]);
                printf ("\n");
                return;
            }
        }
        temp++;
    }
    printf ("0\n");
}

void debug () {
    doors = 4;
    c[0] = 1; c[1] = 1;c[3] = 1;
    code_d ();
    printf ("%d\n", code);
    get_d ();
    for (i = 0; i < doors; i++) printf ("%d ", c[i]);
    
}

int main () {
    //freopen ("a5.inp", "rt", stdin);
    //freopen ("a5.out", "wt", stdout);
    scanf ("%d %d", &n, &m);
    char t[50];
    for (i = 1; i <= n; i++) {
        scanf ("%s", &t);
        for (j = 0; j < m; j++) {
            if (t[j] == 'S') sx = i, sy = j+1, a[i][j+1] = PATH;
            else if (t[j] == '.') a[i][j+1] = PATH;
            else if (t[j] == '_') a[i][j+1] = HOLE;
            else if (t[j] == '^') a[i][j+1] = GL;
            else if (t[j] == 'E') a[i][j+1] = END;
            else if (t[j] == 'K') {
                a[i][j+1] = KEY;
                k[i][j+1] = ++br;
            }
            else a[i][j+1] = t[j] - '0', ++doors;
        }
    }
    scanf ("\n");
    if (br > 0) for (i = 1; i <= br; i++) {
        gets (t);
        //printf ("%s\n", t);
        for (j = 0; j < 50; j++)
            if (t[j] == 'O') v[i][t[j+1]-'0'] = 1;
            else if (t[j] == 'C') v[i][t[j+1]-'0'] = 2;
            else if (t[j] == 'T') v[i][t[j+1]-'0'] = 3;
    }
    if (doors > 0) scanf ("%s", &t);
    for (i = 0; i < doors; i++) if (t[i] == '1') c[i] = 1;
    for (i = 0; i <= n + 1; i++) a[i][0] = a[i][m+1] = HOLE;
    for (j = 0; j <= m + 1; j++) a[0][j] = a[n+1][j] = HOLE;
    solve ();
    //debug ();
    //system ("pause");
    return 0;
}
