
#include <cstdlib>
#include <iostream>
#include <algorithm>
using namespace std;

bool ok(int n, int a[], int b[]) {
    // Solve the 2d problem!
    // Complexity: O(2 ^ (n / 2) * 12)
    int t = 0;
    for (int i = 0; i < n; ++i)
        t += a[i];
    int n1 = n / 2;
    int n2 = n - n1;
    int all = (1 << n1);
    for (int i = 0; i < (1 << n1); ++i) {
        b[i] = 0;
        for (int j = 0; j < n1; ++j)
            if ((i >> j) & 1)
                b[i] += a[j];
    }
    sort(b, b + (1 << n1));
    int z;
    for (int i = 0; i < (1 << n2); ++i) {
        z = 0;
        for (int j = 0; j < n2; ++j)
            if ((i >> j) & 1)
                z += a[n1 + j];
        if (binary_search(b, b + (1 << n1), (t / 2) - z))
            return true;
    }
    return false;
}
bool ok2(int n, int a[]) {
    int t = 0;
    for (int i = 0; i < n; ++i)
        t += a[i];
    for (int i = 0; i < (1 << n); ++i) {
        int b = 0;
        for (int j = 0; j < n; ++j)
            if ((i >> j) & 1)
                b += a[j];
        if (b == t / 2)
            return true;
    }
    return false;
}
inline int getRandom(int a, int b) {
    return a + rand() % (b - a + 1);
}
int main() {
    int n;
    cin >> n;
    int *a = new int[n];
    int *b = new int[n];
    int third = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        third += a[i];
    }
    if (third % 3 != 0) {
        cout << 0 << endl;
        return 0;
    }
    third /= 3;
    int *tmp = new int[1 << 16];
    for (int i = 0; i < (1 << n); ++i) {
        int cur = 0;
        for (int j = 0; j < n; ++j)
            if ((i >> j) & 1)
                cur += a[j];
        if (cur == third) {
            int ii = ((1 << n) - 1) ^ i;
            int k = 0;
            for (int j = 0; j < n; ++j)
                if ((ii >> j) & 1) {
                    b[k++] = a[j];
                }
            if (ok(k, b, tmp)) {
                cout << 1 << endl;
                return 0;
            }
        }
    }
    cout << 0 << endl;
    return 0;
}
