# include <stdio.h>
# include <stdlib.h>
# define MAXN (1<<5) 

int n,m,k,v,x,y,fx,fy,step;
char data[MAXN][MAXN];
char dir[MAXN][MAXN];
struct opashka {
	int x1,x2,y1,y2;
} queue[MAXN*MAXN];
int usedv[MAXN][MAXN];
int usedh[MAXN][MAXN];

void read() {
	scanf("%d %d\n", &n,&m);
	char c;
	for(int i = 1; i <= n; i++){
		for(int j = 1; j <= m; j++) {
			scanf("%c", &c);
			if(c =='K') k++;
			if(c >= '0' && c <= '9') v++; 	
			if(c == 'S') {
				x = i;
				y = j;
				c = '.';	
			}
			if(c == 'E') {
				fx = i;
				fy = j;
				c = '.'; 	
			}
			data[i][j] = c;
		}
		scanf("\n");	
	}
	/*for(int i = 1; i <= n; i++) {
		for(int j = 1; j <= m; j++) {
			printf("%c", data[i][j]);	
		}	
		printf("\n");	
	}*/
}

int exist(int p, int q) {
	if(p> 0 && q >0 && p <=n && q <= m) return 1;
	return 0;
}

int u(int p1,int q1,int p2,int q2) {
	if(usedh[p1][q1] != 0 && usedh[p1][q1] == usedh[p2][q2]) return 1;
	return 0;	
}

void print() {
	//printf("====> %d\n", step);
//	exit(0);	
}

void bfs() {
	//printf("%d %d\n", x,y);
	queue[0].x1 = x;
	queue[0].y1 = y;
	queue[0].x2 = 0;
	queue[0].y2 = 0;
	usedv[x][y] = 1;
	dir[x][y] = '*';
	int start = 0;
	int level = 1;
	int end = 1;	
	int c = 1;
	while(end > start) {
		for(int i = start; i < level; i++) {
			if(queue[i].x2 ==0 && queue[i].y2 == 0) {
				
				int x1 = queue[i].x1;
				int y1 = queue[i].y1;
				if(x1 == fx && y1 == fy) print();
				//usedv[x1][y1] = 1;
				
				if(exist(x1-2,y1) && !u(x1-1,y1,x1-2,y1) && data[x1-1][y1] != '_' && data[x1-2][y1] != '_') {
					queue[end].x2 = x1-1;
					queue[end].y2 = y1;
					queue[end].x1 = x1-2;
					queue[end++].y1 = y1;
					usedh[x1-1][y1] = c;
					usedh[x1-2][y1] = c++;
					//printf("add u\n");			
				}
				
				if(exist(x1,y1-2) && !u(x1,y1-1,x1,y1-2) && data[x1][y1-1] != '_' && data[x1][y1-2] != '_') {
					queue[end].x2 = x1;
					queue[end].y2 = y1-1;
					queue[end].x1 = x1;
					queue[end++].y1 = y1-2; 			
					usedh[x1][y1-1] = c;
					usedh[x1][y1-2] = c++;
					//printf("addl\n");
				}
				
				if(exist(x1+2,y1) && !u(x1+1,y1,x1+2,y1) && data[x1+1][y1] != '_' && data[x1+2][y1] != '_') {
					queue[end].x1 = x1+1;
					queue[end].y1 = y1;
					queue[end].x2 = x1+2;
					queue[end++].y2 = y1; 			
					usedh[x1+1][y1] = c;
					usedh[x1+2][y1] = c++;
					//printf("add d\n");
				}
				
				
				if(exist(x1,y1+2) && !u(x1,y1+1,x1,y1+2) && data[x1][y1+2] != '_' && data[x1][y1+2] != '_') {
					queue[end].x1 = x1;
					queue[end].y1 = y1+1;
					queue[end].x2 = x1;
					queue[end++].y2 = y1+2; 			
					usedh[x1][y1+1] = c;
					usedh[x1][y1+2] = c++;
					//printf("add r\n");
					
				}
						
			} else {
				int x1 = queue[i].x1, x2 = queue[i].x2;
				int y1 = queue[i].y1, y2 = queue[i].y2;	
				if(x1 == x2) {
					if(exist(x1,y1-1) && usedv[x1][y1-1] == 0 && data[x1][y1-1] != '_' && data[x1][y1-1] != '^') {
						queue[end].x1 = x1;
						queue[end].y1 = y1-1;
						queue[end].x2 = 0;
						queue[end++].y2 = 0;
						usedv[x1][y1-1] = 1;
							
					}
					
					if(exist(x2,y2+1) && usedv[x2][y2+1] == 0 && data[x2][y2-1] != '_' && data[x2][y2-1] != '^') {
						queue[end].x1 = x2;
						queue[end].y1 = y2+1;
						queue[end].x2 = 0;
						queue[end++].y2 = 0;
						usedv[x2][y2=1] = 1;
					}
					
					if(exist(x1-1,y1) && !u(x1-1,y1,x2-1,y2) && data[x1-1][y1] != '_' && data[x2-1][y2] != '_') {
						queue[end].x1 = x1-1;
						queue[end].y1 = y1;
						queue[end].x2 = x2-1;
						queue[end++].y2 = y2;
						usedh[x1-1][y1] = c;
						usedh[x2-1][y2] = c++;
						
					}
					
					if(exist(x1+1,y1) && !u(x1+1,y1,x2+1,y2) && data[x1+1][y1] != '_' && data[x2+1][y2] != '_') {
						queue[end].x1 = x1+1;
						queue[end].y1 = y1;
						queue[end].x2 = x2+1;
						queue[end++].y2 = y2;
						usedh[x1+1][y1] = c;
						usedh[x2+1][y2] = c++;
					}
					
				}
				if(y1 == y2) {
					if(exist(x2+1,y2) && usedv[x2+1][y2] == 0 && data[x2+1][y2] != '_' && data[x2+1][y2] != '^') {
						queue[end].x1 = x2+1;
						queue[end].y1 = y2;
						queue[end].x2 = 0;
						queue[end++].y2 = 0;
						usedv[x2+1][y2] = 1;	
					}
					if(exist(x1-1,y1) && usedv[x1-1][y1] == 0 && data[x1-1][y1] != '_' && data[x1-1][y1] != '^') {
						queue[end].x1 = x1-1;
						queue[end].y1 = y1;
						queue[end].x2 = 0;
						queue[end++].y2 = 0;
						usedv[x1-1][y1] = 1;	
					}
					
					if(exist(x1,y1-1) && !u(x1,y1-1,x2,y2-1) && data[x1][y1-1] != '_' && data[x2][y2-1] != '_') {
						queue[end].x1 = x1;
						queue[end].y1 = y1-1;
						queue[end].x2 = x2;
						queue[end++].y2 = y2-1;
						usedh[x1][y1-1] = c;
						usedh[x2][y2-1] = c++;
					}
					if(exist(x1,y1+1) && !u(x1,y1+1,x2,y2+1) && data[x1][y1+1] != '_' && data[x2][y2+1] != '_') {
						queue[end].x1 = x1;
						queue[end].y1 = y1+1;
						queue[end].x2 = x2;
						queue[end++].y2 = y2+1;
						usedh[x1][y1+1] = c;
						usedh[x2][y2+1] = c++;	
					}
						
				}
				
			}
			
		}
		step++;
		start = level;
		level = end;
		//printf("step = %d\n", step);
	}
	/*for(int i = 1; i <= n; i++) {
		for(int j = 1; j <= m; j++) {
			printf("%d ",usedv[i][j]);	
		}	
		printf("\n");
	}*/
}

int main() {
	read();	
	printf("0\n");
	//bfs();
	return 0;
}
